---
title: '<canvas>: The Graphics Canvas element'
slug: Web/HTML/Element/canvas
tags:
  - Canvas
  - Element
  - HTML
  - HTML scripting
  - HTML5
  - Reference
  - Web
---
<div>{{HTMLRef}}</div>

<p>Use the <strong>HTML <code>&lt;canvas&gt;</code> element</strong> with either the <a href="/en-US/docs/Web/API/Canvas_API">canvas scripting API</a> or the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> to draw graphics and animations.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row"><a href="/en-US/docs/Web/Guide/HTML/Content_categories">Content categories</a></th>
   <td><a href="/en-US/docs/Web/Guide/HTML/Content_categories#Flow_content">Flow content</a>, <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Phrasing_content">phrasing content</a>, <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Embedded_content">embedded content</a>, palpable content.</td>
  </tr>
  <tr>
   <th scope="row">Permitted content</th>
   <td>Transparent but with no <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Interactive_content">interactive content</a> descendants except for {{HTMLElement("a")}} elements, {{HTMLElement("button")}} elements, {{HTMLElement("input")}} elements whose {{htmlattrxref("type", "input")}} attribute is <code>checkbox</code>, <code>radio</code>, or <code>button</code>.</td>
  </tr>
  <tr>
   <th scope="row">Tag omission</th>
   <td>{{no_tag_omission}}</td>
  </tr>
  <tr>
   <th scope="row">Permitted parents</th>
   <td>Any element that accepts <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Phrasing_content">phrasing content</a>.</td>
  </tr>
  <tr>
   <th scope="row">Implicit ARIA role</th>
   <td><a href="https://www.w3.org/TR/html-aria/#dfn-no-corresponding-role">No corresponding role</a></td>
  </tr>
  <tr>
   <th scope="row">Permitted ARIA roles</th>
   <td>Any</td>
  </tr>
  <tr>
   <th scope="row">DOM interface</th>
   <td>{{domxref("HTMLCanvasElement")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Attributes">Attributes</h2>

<p>This element's attributes include the <a href="/en-US/docs/Web/HTML/Global_attributes">global attributes</a>.</p>

<dl>
 <dt>{{htmlattrdef("height")}}</dt>
 <dd>The height of the coordinate space in CSS pixels. Defaults to 150.</dd>
 <dt>{{htmlattrdef("moz-opaque")}} {{non-standard_inline}} {{deprecated_inline}}</dt>
 <dd>Lets the canvas know whether or not translucency will be a factor. If the canvas knows there's no translucency, painting performance can be optimized. This is only supported by Mozilla-based browsers; use the standardized {{domxref("HTMLCanvasElement.getContext()", "canvas.getContext('2d', { alpha: false })")}} instead.</dd>
 <dt>{{htmlattrdef("width")}}</dt>
 <dd>The width of the coordinate space in CSS pixels. Defaults to 300.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<h3 id="Alternative_content">Alternative content</h3>

<p>You may (and should) provide alternate content inside the <code>&lt;canvas&gt;</code> block. That content will be rendered both on older browsers that don't support canvas and in browsers with JavaScript disabled. Providing a useful fallback text or sub DOM helps to <a href="/en-US/docs/Web/API/Canvas_API/Tutorial/Hit_regions_and_accessibility">make the canvas more accessible</a>.</p>

<h3 id="Required_&lt;canvas&gt;_tag">Required &lt;/canvas&gt; tag</h3>

<p>Unlike the {{HTMLElement("img")}} element, the {{HTMLElement("canvas")}} element <strong>requires</strong> the closing tag (<code>&lt;/canvas&gt;</code>).</p>

<h3 id="Sizing_the_canvas_using_CSS_versus_HTML">Sizing the canvas using CSS versus HTML</h3>

<p>The displayed size of the canvas can be changed using CSS, but if you do this the image is scaled during rendering to fit the styled size, which can make the final graphics rendering end up being distorted.</p>

<p>It is better to specify your canvas dimensions by setting the <code>width</code> and <code>height</code> attributes directly on the <code>&lt;canvas&gt;</code> elements, either directly in the HTML or by using JavaScript.</p>

<h3 id="Maximum_canvas_size">Maximum canvas size</h3>

<p>The maximum size of a <code>&lt;canvas&gt;</code> element is very large, but the exact size depends on the browser. The following is some data we've collected from various tests and other sources (e.g. <a href="https://stackoverflow.com/questions/6081483/maximum-size-of-a-canvas-element">Stack Overflow</a>):</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Browser</th>
   <th scope="col">Maximum height</th>
   <th scope="col">Maximum width</th>
   <th scope="col">Maximum area</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>Chrome</td>
   <td>32,767 pixels</td>
   <td>32,767 pixels</td>
   <td>268,435,456 pixels (i.e., 16,384 x 16,384)</td>
  </tr>
  <tr>
   <td>Firefox</td>
   <td>32,767 pixels</td>
   <td>32,767 pixels</td>
   <td>472,907,776 pixels (i.e., 22,528 x 20,992)</td>
  </tr>
  <tr>
   <td>Safari</td>
   <td>32,767 pixels</td>
   <td>32,767 pixels</td>
   <td>268,435,456 pixels (i.e., 16,384 x 16,384)</td>
  </tr>
  <tr>
   <td>IE</td>
   <td>8,192 pixels</td>
   <td>8,192 pixels</td>
   <td>?</td>
  </tr>
 </tbody>
</table>

<div class="notecard note">
<p><strong>Note</strong>: Exceeding the maximum dimensions or area renders the canvas unusable — drawing commands will not work.</p>
</div>

<h2 id="Examples">Examples</h2>

<h3 id="HTML">HTML</h3>

<p>This code snippet adds a canvas element to your HTML document. A fallback text is provided if a browser is unable to render the canvas, or if can't read a canvas.</p>

<pre class="brush: html notranslate">&lt;canvas width="300" height="300"&gt;
  An alternative text describing what your canvas displays.
&lt;/canvas&gt;
</pre>

<h3 id="JavaScript">JavaScript</h3>

<p>Then in the JavaScript code, call {{domxref("HTMLCanvasElement.getContext()")}} to get a drawing context and start drawing onto the canvas:</p>

<pre class="brush: js notranslate">const canvas = document.querySelector('canvas');
const ctx = canvas.getContext('2d');
ctx.fillStyle = 'green';
ctx.fillRect(10, 10, 100, 100);</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample('Examples')}}</p>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<h3 id="Alternative_content_2">Alternative content</h3>

<p>The <code>&lt;canvas&gt;</code> element on its own is just a bitmap and does not provide information about any drawn objects. Canvas content is not exposed to accessibility tools as semantic HTML is. In general, you should avoid using canvas in an accessible website or app. The following guides can help to make it more accessible.</p>

<ul>
 <li><a href="/en-US/docs/Web/API/Canvas_API/Tutorial/Hit_regions_and_accessibility">MDN Hit regions and accessability</a></li>
 <li><a href="https://www.w3.org/WAI/PF/HTML/wiki/Canvas_Accessibility_Use_Cases">Canvas accessibility use cases</a></li>
 <li><a href="https://www.w3.org/html/wg/wiki/AddedElementCanvas">Canvas element accessibility issues</a></li>
 <li><a href="https://developer.paciellogroup.com/blog/2012/06/html5-canvas-accessibility-in-firefox-13/">HTML5 Canvas Accessibility in Firefox 13 – by Steve Faulkner</a></li>
 <li><a href="https://html.spec.whatwg.org/multipage/scripting.html#best-practices">Best practices for interactive canvas elements</a></li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'scripting.html#the-canvas-element', '&lt;canvas&gt;')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', 'semantics-scripting.html#the-canvas-element', '&lt;canvas&gt;')}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("html.elements.canvas")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Canvas_API">MDN canvas portal</a></li>
 <li><a href="/en-US/docs/Web/API/Canvas_API/Tutorial">Canvas tutorial</a></li>
 <li><a href="https://simon.html5.org/dump/html5-canvas-cheat-sheet.html">Canvas cheat sheet</a></li>
 <li><a href="/en-US/docs/Web/Demos_of_open_web_technologies">Canvas-related demos</a></li>
 <li><a href="https://developer.apple.com/library/archive/documentation/AudioVideo/Conceptual/HTML-canvas-guide/Introduction/Introduction.html">Canvas introduction by Apple</a></li>
</ul>
